#line 1 "C:/Users/Viktor/Desktop/VREG_click/PIC/vreg_click_example.c"

sbit Chip_Select_Direction at TRISE0_bit;
sbit Chip_Select at LATE0_bit;
sbit Chip_Select1_Direction at TRISA2_bit;
sbit Chip_Select1 at LATA2_bit;
sbit output_sw at LATC0_bit;
sbit output_sw_Direction at TRISC0_bit;




sbit LCD_RS at LATB4_bit;
sbit LCD_EN at LATB5_bit;
sbit LCD_D4 at LATB0_bit;
sbit LCD_D5 at LATB1_bit;
sbit LCD_D6 at LATB2_bit;
sbit LCD_D7 at LATB3_bit;
sbit LCD_RS_Direction at TRISB4_bit;
sbit LCD_EN_Direction at TRISB5_bit;
sbit LCD_D4_Direction at TRISB0_bit;
sbit LCD_D5_Direction at TRISB1_bit;
sbit LCD_D6_Direction at TRISB2_bit;
sbit LCD_D7_Direction at TRISB3_bit;





unsigned int value;
char str[16];
unsigned int input,regout,output;
int vin;


unsigned int getADC(unsigned short channel)
{

 unsigned int tmp;

 Chip_Select1 = 0;
 SPI1_Write(0x06);
 channel = channel << 6;
 tmp = SPI1_Read(channel) & 0x0F;
 tmp = tmp << 8;
 tmp = tmp | SPI1_Read(0);

 Chip_Select1= 1;
 return tmp;

}





void processValue(unsigned int pv, unsigned short channel)
{
 char i1;
 char lcdRow, lcdCol;
 if (channel == 0){ lcdCol = 1; lcdRow = 2;}
 if (channel == 1){ lcdCol = 6; lcdRow = 1;}
 if (channel == 2){ lcdCol = 11; lcdRow = 2;}


 i1 = pv / 1000 + 48;
 Lcd_Chr(lcdRow, lcdCol, i1);
 pv = pv % 1000;
 i1 = pv / 100 + 48;
 Lcd_Chr(lcdRow, lcdCol+1, i1);
 Lcd_Chr(lcdRow, lcdCol+2, '.');
 pv = pv % 100;
 i1 = pv / 10 + 48;
 Lcd_Chr(lcdRow, lcdCol+3, i1);
 pv = pv % 10;
 i1 = pv + 48;
 Lcd_Chr(lcdRow, lcdCol+4, i1);
 Lcd_Chr(lcdRow, lcdCol+5, 'V');
}





void DAC_Output(unsigned int valueDAC)
{
 char temp;
 Chip_Select = 0;

 temp = (valueDAC >> 8) & 0x0F;
 temp |= 0x30;
 SPI1_Write(temp);

 temp = valueDAC;
 SPI1_Write(temp);
 Chip_Select = 1;
}


void main(){

 int set_value, vin;
 bit reset;

 ANSELA = 0;
 ANSELE = 0;
 ANSELB = 0;
 anselc = 0;
 anseld = 0;
 trisd = 0xff;
 SLRCON = 0;
 value = 0;



 Chip_Select_Direction = 0;
 Chip_Select = 1;

 Chip_Select1 = 1;
 Chip_Select1_Direction = 0;
 output_sw_Direction = 0;
 reset = 0;
 vin = 0;
 input = 0;
 regout = 0;
 output = 0;

 TRISA0_bit = 1;
 TRISA1_bit = 1;
 set_value = 0;

 SPI1_Init_Advanced(_SPI_MASTER_OSC_DIV64, _SPI_DATA_SAMPLE_MIDDLE, _SPI_CLK_IDLE_LOW, _SPI_LOW_2_HIGH);

 Lcd_Init();
 ADC_Init();
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);


 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Out(1,1,"IN           OUT");
 Lcd_Out(2,1,"       RG       ");



 value = 600;
 set_value = 950;

 while(1)
 {

 if(RD5_bit == 1){ output_sw = 1;}
 if(RD5_bit == 0){ output_sw = 0; reset = 0;}


 if ((RA0_bit) && (value < 4095))
 {
 set_value++;
 }


 else if ((RA1_bit) && (value > 0))
 {
 set_value--;
 }

 if(RD0_bit){set_value = 180;}
 if(RD1_bit){set_value = 330;}
 if(RD2_bit){set_value = 900;}
 if(RD3_bit){set_value = 1400;}

 regout = getADC(0)/1.82;
 ProcessValue(regout,1);
 Delay_ms(10);
 input = getADC(2)/1.82;
 vin = input - 150;
 ProcessValue(input,0);
 Delay_ms(10);


 if(reset == 0)
 value = 0;

 if(output_sw == 1)
 {
 reset = 1;

 while((output - set_value) > 50 | (set_value - output) > 50)
 {

 output = getADC(1)/1.82;
 if(vin < set_value)
 {
 Lcd_Cmd(_LCD_CLEAR);
 LCD_OUT(1,1,"NOT ENOUGH");
 LCD_OUT(2,1,"INPUT VOLTS");
 output_sw = 0;
 while(vin < set_value)
 {
 input = getADC(2)/1.82;
 vin = input - 200;
 }

 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Out(1,1,"IN           OUT");
 Lcd_Out(2,1,"       RG       ");
 output_sw = 1;
 }

 if(output < set_value)
 {
 value = value + 1;
 if(value>4095){value = 4095;}
 }

 if(output > set_value)
 {
 value = value - 1;
 if(value<1){value = 2;}
 }

 DAC_Output(value);
 }

 }

 if(output < set_value)
 {
 value = value + 1;
 if(value>4095) {value = 4095;}
 }

 if(output > set_value)
 {
 value = value - 1;
 if(value<1) {value = 2;}
 }

 DAC_Output(value);
 output = getADC(1)/1.82;
 ProcessValue(output,2);
 Delay_ms(10);
 }

}
