
_getADC:

;vreg_click_example.c,35 :: 		unsigned int getADC(unsigned short channel)
;vreg_click_example.c,40 :: 		Chip_Select1 = 0;                               // Select MCP3204
	BCF         LATA2_bit+0, BitPos(LATA2_bit+0) 
;vreg_click_example.c,41 :: 		SPI1_Write(0x06);                              // SPI communication using 8-bit segments
	MOVLW       6
	MOVWF       FARG_SPI1_Write_data_+0 
	CALL        _SPI1_Write+0, 0
;vreg_click_example.c,42 :: 		channel = channel << 6;                        // Bits 7 & 6 define ADC input
	MOVLW       6
	MOVWF       R1 
	MOVF        FARG_getADC_channel+0, 0 
	MOVWF       R0 
	MOVF        R1, 0 
L__getADC39:
	BZ          L__getADC40
	RLCF        R0, 1 
	BCF         R0, 0 
	ADDLW       255
	GOTO        L__getADC39
L__getADC40:
	MOVF        R0, 0 
	MOVWF       FARG_getADC_channel+0 
;vreg_click_example.c,43 :: 		tmp = SPI1_Read(channel) & 0x0F;               // Get first 8 bits of ADC value
	MOVF        R0, 0 
	MOVWF       FARG_SPI1_Read_buffer+0 
	CALL        _SPI1_Read+0, 0
	MOVLW       15
	ANDWF       R0, 0 
	MOVWF       getADC_tmp_L0+0 
	CLRF        getADC_tmp_L0+1 
	MOVLW       0
	ANDWF       getADC_tmp_L0+1, 1 
	MOVLW       0
	MOVWF       getADC_tmp_L0+1 
;vreg_click_example.c,44 :: 		tmp = tmp << 8;                                // Shift ADC value by 8
	MOVF        getADC_tmp_L0+0, 0 
	MOVWF       getADC_tmp_L0+1 
	CLRF        getADC_tmp_L0+0 
;vreg_click_example.c,45 :: 		tmp = tmp | SPI1_Read(0);                      // Get remaining 4 bits of ADC value
	CLRF        FARG_SPI1_Read_buffer+0 
	CALL        _SPI1_Read+0, 0
	MOVLW       0
	MOVWF       R1 
	MOVF        getADC_tmp_L0+0, 0 
	IORWF       R0, 1 
	MOVF        getADC_tmp_L0+1, 0 
	IORWF       R1, 1 
	MOVF        R0, 0 
	MOVWF       getADC_tmp_L0+0 
	MOVF        R1, 0 
	MOVWF       getADC_tmp_L0+1 
;vreg_click_example.c,47 :: 		Chip_Select1= 1;                                // Deselect MCP3204
	BSF         LATA2_bit+0, BitPos(LATA2_bit+0) 
;vreg_click_example.c,48 :: 		return tmp;                                    // Returns 12-bit ADC value
;vreg_click_example.c,50 :: 		}
L_end_getADC:
	RETURN      0
; end of _getADC

_processValue:

;vreg_click_example.c,56 :: 		void processValue(unsigned int pv, unsigned short channel)
;vreg_click_example.c,60 :: 		if (channel == 0){ lcdCol = 1;  lcdRow = 2;}
	MOVF        FARG_processValue_channel+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_processValue0
	MOVLW       1
	MOVWF       processValue_lcdCol_L0+0 
	MOVLW       2
	MOVWF       processValue_lcdRow_L0+0 
L_processValue0:
;vreg_click_example.c,61 :: 		if (channel == 1){ lcdCol = 6;  lcdRow = 1;}
	MOVF        FARG_processValue_channel+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_processValue1
	MOVLW       6
	MOVWF       processValue_lcdCol_L0+0 
	MOVLW       1
	MOVWF       processValue_lcdRow_L0+0 
L_processValue1:
;vreg_click_example.c,62 :: 		if (channel == 2){ lcdCol = 11;  lcdRow = 2;}
	MOVF        FARG_processValue_channel+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L_processValue2
	MOVLW       11
	MOVWF       processValue_lcdCol_L0+0 
	MOVLW       2
	MOVWF       processValue_lcdRow_L0+0 
L_processValue2:
;vreg_click_example.c,65 :: 		i1 = pv / 1000 + 48;              // Get thousandth digit of the ADC result
	MOVLW       232
	MOVWF       R4 
	MOVLW       3
	MOVWF       R5 
	MOVF        FARG_processValue_pv+0, 0 
	MOVWF       R0 
	MOVF        FARG_processValue_pv+1, 0 
	MOVWF       R1 
	CALL        _Div_16X16_U+0, 0
	MOVLW       48
	ADDWF       R0, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
;vreg_click_example.c,66 :: 		Lcd_Chr(lcdRow, lcdCol, i1);      // Display it on Lcd
	MOVF        processValue_lcdRow_L0+0, 0 
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVF        processValue_lcdCol_L0+0, 0 
	MOVWF       FARG_Lcd_Chr_column+0 
	CALL        _Lcd_Chr+0, 0
;vreg_click_example.c,67 :: 		pv = pv % 1000;
	MOVLW       232
	MOVWF       R4 
	MOVLW       3
	MOVWF       R5 
	MOVF        FARG_processValue_pv+0, 0 
	MOVWF       R0 
	MOVF        FARG_processValue_pv+1, 0 
	MOVWF       R1 
	CALL        _Div_16X16_U+0, 0
	MOVF        R8, 0 
	MOVWF       R0 
	MOVF        R9, 0 
	MOVWF       R1 
	MOVF        R0, 0 
	MOVWF       FARG_processValue_pv+0 
	MOVF        R1, 0 
	MOVWF       FARG_processValue_pv+1 
;vreg_click_example.c,68 :: 		i1 = pv / 100 + 48;               // Get hundreth digit of the ADC result
	MOVLW       100
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Div_16X16_U+0, 0
	MOVLW       48
	ADDWF       R0, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
;vreg_click_example.c,69 :: 		Lcd_Chr(lcdRow, lcdCol+1, i1);    // Display it on Lcd
	MOVF        processValue_lcdRow_L0+0, 0 
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVF        processValue_lcdCol_L0+0, 0 
	ADDLW       1
	MOVWF       FARG_Lcd_Chr_column+0 
	CALL        _Lcd_Chr+0, 0
;vreg_click_example.c,70 :: 		Lcd_Chr(lcdRow, lcdCol+2, '.');
	MOVF        processValue_lcdRow_L0+0, 0 
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       2
	ADDWF       processValue_lcdCol_L0+0, 0 
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVLW       46
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;vreg_click_example.c,71 :: 		pv = pv % 100;
	MOVLW       100
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	MOVF        FARG_processValue_pv+0, 0 
	MOVWF       R0 
	MOVF        FARG_processValue_pv+1, 0 
	MOVWF       R1 
	CALL        _Div_16X16_U+0, 0
	MOVF        R8, 0 
	MOVWF       R0 
	MOVF        R9, 0 
	MOVWF       R1 
	MOVF        R0, 0 
	MOVWF       FARG_processValue_pv+0 
	MOVF        R1, 0 
	MOVWF       FARG_processValue_pv+1 
;vreg_click_example.c,72 :: 		i1 = pv / 10 + 48;                // Get tenth digit of the ADC result
	MOVLW       10
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Div_16X16_U+0, 0
	MOVLW       48
	ADDWF       R0, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
;vreg_click_example.c,73 :: 		Lcd_Chr(lcdRow, lcdCol+3, i1);    // Display it on Lcd
	MOVF        processValue_lcdRow_L0+0, 0 
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       3
	ADDWF       processValue_lcdCol_L0+0, 0 
	MOVWF       FARG_Lcd_Chr_column+0 
	CALL        _Lcd_Chr+0, 0
;vreg_click_example.c,74 :: 		pv = pv % 10;
	MOVLW       10
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	MOVF        FARG_processValue_pv+0, 0 
	MOVWF       R0 
	MOVF        FARG_processValue_pv+1, 0 
	MOVWF       R1 
	CALL        _Div_16X16_U+0, 0
	MOVF        R8, 0 
	MOVWF       R0 
	MOVF        R9, 0 
	MOVWF       R1 
	MOVF        R0, 0 
	MOVWF       FARG_processValue_pv+0 
	MOVF        R1, 0 
	MOVWF       FARG_processValue_pv+1 
;vreg_click_example.c,75 :: 		i1 = pv + 48;                     // Get ones digit of the ADC result
	MOVLW       48
	ADDWF       R0, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
;vreg_click_example.c,76 :: 		Lcd_Chr(lcdRow, lcdCol+4, i1);    // Display it on Lcd
	MOVF        processValue_lcdRow_L0+0, 0 
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       4
	ADDWF       processValue_lcdCol_L0+0, 0 
	MOVWF       FARG_Lcd_Chr_column+0 
	CALL        _Lcd_Chr+0, 0
;vreg_click_example.c,77 :: 		Lcd_Chr(lcdRow, lcdCol+5, 'V');
	MOVF        processValue_lcdRow_L0+0, 0 
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       5
	ADDWF       processValue_lcdCol_L0+0, 0 
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVLW       86
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;vreg_click_example.c,78 :: 		}
L_end_processValue:
	RETURN      0
; end of _processValue

_DAC_Output:

;vreg_click_example.c,84 :: 		void DAC_Output(unsigned int valueDAC)
;vreg_click_example.c,87 :: 		Chip_Select = 0;                   // Select DAC chip
	BCF         LATE0_bit+0, BitPos(LATE0_bit+0) 
;vreg_click_example.c,89 :: 		temp = (valueDAC >> 8) & 0x0F;     // Store valueDAC[11..8] to temp[3..0]
	MOVF        FARG_DAC_Output_valueDAC+1, 0 
	MOVWF       R0 
	CLRF        R1 
	MOVLW       15
	ANDWF       R0, 0 
	MOVWF       FARG_SPI1_Write_data_+0 
;vreg_click_example.c,90 :: 		temp |= 0x30;                      // Define DAC setting, see MCP4921 datasheet
	MOVLW       48
	IORWF       FARG_SPI1_Write_data_+0, 1 
;vreg_click_example.c,91 :: 		SPI1_Write(temp);                  // Send high byte via SPI
	CALL        _SPI1_Write+0, 0
;vreg_click_example.c,94 :: 		SPI1_Write(temp);                  // Send low byte via SPI
	MOVF        FARG_DAC_Output_valueDAC+0, 0 
	MOVWF       FARG_SPI1_Write_data_+0 
	CALL        _SPI1_Write+0, 0
;vreg_click_example.c,95 :: 		Chip_Select = 1;                   // Deselect DAC chip
	BSF         LATE0_bit+0, BitPos(LATE0_bit+0) 
;vreg_click_example.c,96 :: 		}
L_end_DAC_Output:
	RETURN      0
; end of _DAC_Output

_main:

;vreg_click_example.c,99 :: 		void main(){
;vreg_click_example.c,104 :: 		ANSELA = 0;
	CLRF        ANSELA+0 
;vreg_click_example.c,105 :: 		ANSELE = 0;                     // Configure PORTA pins as digital
	CLRF        ANSELE+0 
;vreg_click_example.c,106 :: 		ANSELB = 0;                        // Configure PORTB pins as digital
	CLRF        ANSELB+0 
;vreg_click_example.c,107 :: 		anselc = 0;
	CLRF        ANSELC+0 
;vreg_click_example.c,108 :: 		anseld = 0;
	CLRF        ANSELD+0 
;vreg_click_example.c,109 :: 		trisd = 0xff;
	MOVLW       255
	MOVWF       TRISD+0 
;vreg_click_example.c,110 :: 		SLRCON = 0;                        // Configure all PORTS at the standard Slew rate
	CLRF        SLRCON+0 
;vreg_click_example.c,111 :: 		value = 0;
	CLRF        _value+0 
	CLRF        _value+1 
;vreg_click_example.c,115 :: 		Chip_Select_Direction = 0;         // Set CS# pin as Output
	BCF         TRISE0_bit+0, BitPos(TRISE0_bit+0) 
;vreg_click_example.c,116 :: 		Chip_Select = 1;                   // Deselect DAC
	BSF         LATE0_bit+0, BitPos(LATE0_bit+0) 
;vreg_click_example.c,118 :: 		Chip_Select1 = 1;                 // Deselect MCP3204
	BSF         LATA2_bit+0, BitPos(LATA2_bit+0) 
;vreg_click_example.c,119 :: 		Chip_Select1_Direction = 0;
	BCF         TRISA2_bit+0, BitPos(TRISA2_bit+0) 
;vreg_click_example.c,120 :: 		output_sw_Direction = 0;
	BCF         TRISC0_bit+0, BitPos(TRISC0_bit+0) 
;vreg_click_example.c,121 :: 		reset = 0;
	BCF         main_reset_L0+0, BitPos(main_reset_L0+0) 
;vreg_click_example.c,122 :: 		vin = 0;
	CLRF        main_vin_L0+0 
	CLRF        main_vin_L0+1 
;vreg_click_example.c,123 :: 		input = 0;
	CLRF        _input+0 
	CLRF        _input+1 
;vreg_click_example.c,124 :: 		regout = 0;
	CLRF        _regout+0 
	CLRF        _regout+1 
;vreg_click_example.c,125 :: 		output = 0;
	CLRF        _output+0 
	CLRF        _output+1 
;vreg_click_example.c,127 :: 		TRISA0_bit = 1;                    // Set RA0 pin as input
	BSF         TRISA0_bit+0, BitPos(TRISA0_bit+0) 
;vreg_click_example.c,128 :: 		TRISA1_bit = 1;                    // Set RA1 pin as input
	BSF         TRISA1_bit+0, BitPos(TRISA1_bit+0) 
;vreg_click_example.c,129 :: 		set_value = 0;
	CLRF        main_set_value_L0+0 
	CLRF        main_set_value_L0+1 
;vreg_click_example.c,131 :: 		SPI1_Init_Advanced(_SPI_MASTER_OSC_DIV64, _SPI_DATA_SAMPLE_MIDDLE, _SPI_CLK_IDLE_LOW, _SPI_LOW_2_HIGH);
	MOVLW       2
	MOVWF       FARG_SPI1_Init_Advanced_master+0 
	CLRF        FARG_SPI1_Init_Advanced_data_sample+0 
	CLRF        FARG_SPI1_Init_Advanced_clock_idle+0 
	MOVLW       1
	MOVWF       FARG_SPI1_Init_Advanced_transmit_edge+0 
	CALL        _SPI1_Init_Advanced+0, 0
;vreg_click_example.c,133 :: 		Lcd_Init();                        // Initialize Lcd
	CALL        _Lcd_Init+0, 0
;vreg_click_example.c,134 :: 		ADC_Init();
	CALL        _ADC_Init+0, 0
;vreg_click_example.c,135 :: 		Lcd_Cmd(_LCD_CLEAR);               // Clear display
	MOVLW       1
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;vreg_click_example.c,136 :: 		Lcd_Cmd(_LCD_CURSOR_OFF);          // Cursor off
	MOVLW       12
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;vreg_click_example.c,139 :: 		Lcd_Cmd(_LCD_CLEAR);               // Clear display
	MOVLW       1
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;vreg_click_example.c,140 :: 		Lcd_Out(1,1,"IN           OUT");
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr1_vreg_click_example+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr1_vreg_click_example+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;vreg_click_example.c,141 :: 		Lcd_Out(2,1,"       RG       ");
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr2_vreg_click_example+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr2_vreg_click_example+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;vreg_click_example.c,145 :: 		value = 600;
	MOVLW       88
	MOVWF       _value+0 
	MOVLW       2
	MOVWF       _value+1 
;vreg_click_example.c,146 :: 		set_value = 950;
	MOVLW       182
	MOVWF       main_set_value_L0+0 
	MOVLW       3
	MOVWF       main_set_value_L0+1 
;vreg_click_example.c,148 :: 		while(1)
L_main3:
;vreg_click_example.c,151 :: 		if(RD5_bit == 1){ output_sw = 1;}
	BTFSS       RD5_bit+0, BitPos(RD5_bit+0) 
	GOTO        L_main5
	BSF         LATC0_bit+0, BitPos(LATC0_bit+0) 
L_main5:
;vreg_click_example.c,152 :: 		if(RD5_bit == 0){ output_sw = 0; reset = 0;}
	BTFSC       RD5_bit+0, BitPos(RD5_bit+0) 
	GOTO        L_main6
	BCF         LATC0_bit+0, BitPos(LATC0_bit+0) 
	BCF         main_reset_L0+0, BitPos(main_reset_L0+0) 
L_main6:
;vreg_click_example.c,155 :: 		if ((RA0_bit) && (value < 4095))
	BTFSS       RA0_bit+0, BitPos(RA0_bit+0) 
	GOTO        L_main9
	MOVLW       15
	SUBWF       _value+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main44
	MOVLW       255
	SUBWF       _value+0, 0 
L__main44:
	BTFSC       STATUS+0, 0 
	GOTO        L_main9
L__main37:
;vreg_click_example.c,157 :: 		set_value++;                              //   increment value
	INFSNZ      main_set_value_L0+0, 1 
	INCF        main_set_value_L0+1, 1 
;vreg_click_example.c,158 :: 		}
	GOTO        L_main10
L_main9:
;vreg_click_example.c,161 :: 		else if ((RA1_bit) && (value > 0))
	BTFSS       RA1_bit+0, BitPos(RA1_bit+0) 
	GOTO        L_main13
	MOVLW       0
	MOVWF       R0 
	MOVF        _value+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main45
	MOVF        _value+0, 0 
	SUBLW       0
L__main45:
	BTFSC       STATUS+0, 0 
	GOTO        L_main13
L__main36:
;vreg_click_example.c,163 :: 		set_value--;                            //   decrement value
	MOVLW       1
	SUBWF       main_set_value_L0+0, 1 
	MOVLW       0
	SUBWFB      main_set_value_L0+1, 1 
;vreg_click_example.c,164 :: 		}
L_main13:
L_main10:
;vreg_click_example.c,166 :: 		if(RD0_bit){set_value = 180;}
	BTFSS       RD0_bit+0, BitPos(RD0_bit+0) 
	GOTO        L_main14
	MOVLW       180
	MOVWF       main_set_value_L0+0 
	MOVLW       0
	MOVWF       main_set_value_L0+1 
L_main14:
;vreg_click_example.c,167 :: 		if(RD1_bit){set_value = 330;}
	BTFSS       RD1_bit+0, BitPos(RD1_bit+0) 
	GOTO        L_main15
	MOVLW       74
	MOVWF       main_set_value_L0+0 
	MOVLW       1
	MOVWF       main_set_value_L0+1 
L_main15:
;vreg_click_example.c,168 :: 		if(RD2_bit){set_value = 900;}
	BTFSS       RD2_bit+0, BitPos(RD2_bit+0) 
	GOTO        L_main16
	MOVLW       132
	MOVWF       main_set_value_L0+0 
	MOVLW       3
	MOVWF       main_set_value_L0+1 
L_main16:
;vreg_click_example.c,169 :: 		if(RD3_bit){set_value = 1400;}
	BTFSS       RD3_bit+0, BitPos(RD3_bit+0) 
	GOTO        L_main17
	MOVLW       120
	MOVWF       main_set_value_L0+0 
	MOVLW       5
	MOVWF       main_set_value_L0+1 
L_main17:
;vreg_click_example.c,171 :: 		regout = getADC(0)/1.82;       // Get ADC result from Channel 0
	CLRF        FARG_getADC_channel+0 
	CALL        _getADC+0, 0
	CALL        _word2double+0, 0
	MOVLW       195
	MOVWF       R4 
	MOVLW       245
	MOVWF       R5 
	MOVLW       104
	MOVWF       R6 
	MOVLW       127
	MOVWF       R7 
	CALL        _Div_32x32_FP+0, 0
	CALL        _double2word+0, 0
	MOVF        R0, 0 
	MOVWF       _regout+0 
	MOVF        R1, 0 
	MOVWF       _regout+1 
;vreg_click_example.c,172 :: 		ProcessValue(regout,1);        // Writes measured value to Lcd
	MOVF        R0, 0 
	MOVWF       FARG_processValue_pv+0 
	MOVF        R1, 0 
	MOVWF       FARG_processValue_pv+1 
	MOVLW       1
	MOVWF       FARG_processValue_channel+0 
	CALL        _processValue+0, 0
;vreg_click_example.c,173 :: 		Delay_ms(10);                  // Wait 10ms
	MOVLW       26
	MOVWF       R12, 0
	MOVLW       248
	MOVWF       R13, 0
L_main18:
	DECFSZ      R13, 1, 1
	BRA         L_main18
	DECFSZ      R12, 1, 1
	BRA         L_main18
	NOP
;vreg_click_example.c,174 :: 		input = getADC(2)/1.82;        // Get ADC result from Channel 2
	MOVLW       2
	MOVWF       FARG_getADC_channel+0 
	CALL        _getADC+0, 0
	CALL        _word2double+0, 0
	MOVLW       195
	MOVWF       R4 
	MOVLW       245
	MOVWF       R5 
	MOVLW       104
	MOVWF       R6 
	MOVLW       127
	MOVWF       R7 
	CALL        _Div_32x32_FP+0, 0
	CALL        _double2word+0, 0
	MOVF        R0, 0 
	MOVWF       _input+0 
	MOVF        R1, 0 
	MOVWF       _input+1 
;vreg_click_example.c,175 :: 		vin = input - 150;
	MOVLW       150
	SUBWF       R0, 0 
	MOVWF       main_vin_L0+0 
	MOVLW       0
	SUBWFB      R1, 0 
	MOVWF       main_vin_L0+1 
;vreg_click_example.c,176 :: 		ProcessValue(input,0);         // Writes measured value to Lcd
	MOVF        R0, 0 
	MOVWF       FARG_processValue_pv+0 
	MOVF        R1, 0 
	MOVWF       FARG_processValue_pv+1 
	CLRF        FARG_processValue_channel+0 
	CALL        _processValue+0, 0
;vreg_click_example.c,177 :: 		Delay_ms(10);                  // Wait 10ms
	MOVLW       26
	MOVWF       R12, 0
	MOVLW       248
	MOVWF       R13, 0
L_main19:
	DECFSZ      R13, 1, 1
	BRA         L_main19
	DECFSZ      R12, 1, 1
	BRA         L_main19
	NOP
;vreg_click_example.c,180 :: 		if(reset == 0)
	BTFSC       main_reset_L0+0, BitPos(main_reset_L0+0) 
	GOTO        L_main20
;vreg_click_example.c,181 :: 		value = 0;
	CLRF        _value+0 
	CLRF        _value+1 
L_main20:
;vreg_click_example.c,183 :: 		if(output_sw == 1)
	BTFSS       LATC0_bit+0, BitPos(LATC0_bit+0) 
	GOTO        L_main21
;vreg_click_example.c,185 :: 		reset = 1;
	BSF         main_reset_L0+0, BitPos(main_reset_L0+0) 
;vreg_click_example.c,187 :: 		while((output - set_value) > 50 | (set_value - output) > 50)
L_main22:
	MOVF        main_set_value_L0+0, 0 
	SUBWF       _output+0, 0 
	MOVWF       R0 
	MOVF        main_set_value_L0+1, 0 
	SUBWFB      _output+1, 0 
	MOVWF       R1 
	MOVLW       0
	MOVWF       R3 
	MOVF        R1, 0 
	SUBWF       R3, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main46
	MOVF        R0, 0 
	SUBLW       50
L__main46:
	MOVLW       1
	BTFSC       STATUS+0, 0 
	MOVLW       0
	MOVWF       R3 
	MOVF        _output+0, 0 
	SUBWF       main_set_value_L0+0, 0 
	MOVWF       R1 
	MOVF        _output+1, 0 
	SUBWFB      main_set_value_L0+1, 0 
	MOVWF       R2 
	MOVLW       0
	MOVWF       R0 
	MOVF        R2, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main47
	MOVF        R1, 0 
	SUBLW       50
L__main47:
	MOVLW       1
	BTFSC       STATUS+0, 0 
	MOVLW       0
	MOVWF       R0 
	MOVF        R3, 0 
	IORWF       R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_main23
;vreg_click_example.c,190 :: 		output = getADC(1)/1.82;       // Get ADC result from Channel 1
	MOVLW       1
	MOVWF       FARG_getADC_channel+0 
	CALL        _getADC+0, 0
	CALL        _word2double+0, 0
	MOVLW       195
	MOVWF       R4 
	MOVLW       245
	MOVWF       R5 
	MOVLW       104
	MOVWF       R6 
	MOVLW       127
	MOVWF       R7 
	CALL        _Div_32x32_FP+0, 0
	CALL        _double2word+0, 0
	MOVF        R0, 0 
	MOVWF       _output+0 
	MOVF        R1, 0 
	MOVWF       _output+1 
;vreg_click_example.c,191 :: 		if(vin < set_value)
	MOVLW       128
	XORWF       main_vin_L0+1, 0 
	MOVWF       R0 
	MOVLW       128
	XORWF       main_set_value_L0+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main48
	MOVF        main_set_value_L0+0, 0 
	SUBWF       main_vin_L0+0, 0 
L__main48:
	BTFSC       STATUS+0, 0 
	GOTO        L_main24
;vreg_click_example.c,193 :: 		Lcd_Cmd(_LCD_CLEAR);
	MOVLW       1
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;vreg_click_example.c,194 :: 		LCD_OUT(1,1,"NOT ENOUGH");
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr3_vreg_click_example+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr3_vreg_click_example+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;vreg_click_example.c,195 :: 		LCD_OUT(2,1,"INPUT VOLTS");
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr4_vreg_click_example+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr4_vreg_click_example+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;vreg_click_example.c,196 :: 		output_sw = 0;
	BCF         LATC0_bit+0, BitPos(LATC0_bit+0) 
;vreg_click_example.c,197 :: 		while(vin < set_value)
L_main25:
	MOVLW       128
	XORWF       main_vin_L0+1, 0 
	MOVWF       R0 
	MOVLW       128
	XORWF       main_set_value_L0+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main49
	MOVF        main_set_value_L0+0, 0 
	SUBWF       main_vin_L0+0, 0 
L__main49:
	BTFSC       STATUS+0, 0 
	GOTO        L_main26
;vreg_click_example.c,199 :: 		input = getADC(2)/1.82;       // Get ADC result from Channel 2
	MOVLW       2
	MOVWF       FARG_getADC_channel+0 
	CALL        _getADC+0, 0
	CALL        _word2double+0, 0
	MOVLW       195
	MOVWF       R4 
	MOVLW       245
	MOVWF       R5 
	MOVLW       104
	MOVWF       R6 
	MOVLW       127
	MOVWF       R7 
	CALL        _Div_32x32_FP+0, 0
	CALL        _double2word+0, 0
	MOVF        R0, 0 
	MOVWF       _input+0 
	MOVF        R1, 0 
	MOVWF       _input+1 
;vreg_click_example.c,200 :: 		vin = input - 200;
	MOVLW       200
	SUBWF       R0, 0 
	MOVWF       main_vin_L0+0 
	MOVLW       0
	SUBWFB      R1, 0 
	MOVWF       main_vin_L0+1 
;vreg_click_example.c,201 :: 		}
	GOTO        L_main25
L_main26:
;vreg_click_example.c,203 :: 		Lcd_Cmd(_LCD_CLEAR);               // Clear display
	MOVLW       1
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;vreg_click_example.c,204 :: 		Lcd_Out(1,1,"IN           OUT");
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr5_vreg_click_example+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr5_vreg_click_example+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;vreg_click_example.c,205 :: 		Lcd_Out(2,1,"       RG       ");
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr6_vreg_click_example+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr6_vreg_click_example+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;vreg_click_example.c,206 :: 		output_sw = 1;
	BSF         LATC0_bit+0, BitPos(LATC0_bit+0) 
;vreg_click_example.c,207 :: 		}
L_main24:
;vreg_click_example.c,209 :: 		if(output < set_value)
	MOVF        main_set_value_L0+1, 0 
	SUBWF       _output+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main50
	MOVF        main_set_value_L0+0, 0 
	SUBWF       _output+0, 0 
L__main50:
	BTFSC       STATUS+0, 0 
	GOTO        L_main27
;vreg_click_example.c,211 :: 		value = value + 1;
	INFSNZ      _value+0, 1 
	INCF        _value+1, 1 
;vreg_click_example.c,212 :: 		if(value>4095){value = 4095;}
	MOVF        _value+1, 0 
	SUBLW       15
	BTFSS       STATUS+0, 2 
	GOTO        L__main51
	MOVF        _value+0, 0 
	SUBLW       255
L__main51:
	BTFSC       STATUS+0, 0 
	GOTO        L_main28
	MOVLW       255
	MOVWF       _value+0 
	MOVLW       15
	MOVWF       _value+1 
L_main28:
;vreg_click_example.c,213 :: 		}
L_main27:
;vreg_click_example.c,215 :: 		if(output > set_value)
	MOVF        _output+1, 0 
	SUBWF       main_set_value_L0+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main52
	MOVF        _output+0, 0 
	SUBWF       main_set_value_L0+0, 0 
L__main52:
	BTFSC       STATUS+0, 0 
	GOTO        L_main29
;vreg_click_example.c,217 :: 		value = value - 1;
	MOVLW       1
	SUBWF       _value+0, 1 
	MOVLW       0
	SUBWFB      _value+1, 1 
;vreg_click_example.c,218 :: 		if(value<1){value = 2;}
	MOVLW       0
	SUBWF       _value+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main53
	MOVLW       1
	SUBWF       _value+0, 0 
L__main53:
	BTFSC       STATUS+0, 0 
	GOTO        L_main30
	MOVLW       2
	MOVWF       _value+0 
	MOVLW       0
	MOVWF       _value+1 
L_main30:
;vreg_click_example.c,219 :: 		}
L_main29:
;vreg_click_example.c,221 :: 		DAC_Output(value);
	MOVF        _value+0, 0 
	MOVWF       FARG_DAC_Output_valueDAC+0 
	MOVF        _value+1, 0 
	MOVWF       FARG_DAC_Output_valueDAC+1 
	CALL        _DAC_Output+0, 0
;vreg_click_example.c,222 :: 		}
	GOTO        L_main22
L_main23:
;vreg_click_example.c,224 :: 		}
L_main21:
;vreg_click_example.c,226 :: 		if(output < set_value)
	MOVF        main_set_value_L0+1, 0 
	SUBWF       _output+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main54
	MOVF        main_set_value_L0+0, 0 
	SUBWF       _output+0, 0 
L__main54:
	BTFSC       STATUS+0, 0 
	GOTO        L_main31
;vreg_click_example.c,228 :: 		value = value + 1;
	INFSNZ      _value+0, 1 
	INCF        _value+1, 1 
;vreg_click_example.c,229 :: 		if(value>4095) {value = 4095;}
	MOVF        _value+1, 0 
	SUBLW       15
	BTFSS       STATUS+0, 2 
	GOTO        L__main55
	MOVF        _value+0, 0 
	SUBLW       255
L__main55:
	BTFSC       STATUS+0, 0 
	GOTO        L_main32
	MOVLW       255
	MOVWF       _value+0 
	MOVLW       15
	MOVWF       _value+1 
L_main32:
;vreg_click_example.c,230 :: 		}
L_main31:
;vreg_click_example.c,232 :: 		if(output > set_value)
	MOVF        _output+1, 0 
	SUBWF       main_set_value_L0+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main56
	MOVF        _output+0, 0 
	SUBWF       main_set_value_L0+0, 0 
L__main56:
	BTFSC       STATUS+0, 0 
	GOTO        L_main33
;vreg_click_example.c,234 :: 		value = value - 1;
	MOVLW       1
	SUBWF       _value+0, 1 
	MOVLW       0
	SUBWFB      _value+1, 1 
;vreg_click_example.c,235 :: 		if(value<1) {value = 2;}
	MOVLW       0
	SUBWF       _value+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main57
	MOVLW       1
	SUBWF       _value+0, 0 
L__main57:
	BTFSC       STATUS+0, 0 
	GOTO        L_main34
	MOVLW       2
	MOVWF       _value+0 
	MOVLW       0
	MOVWF       _value+1 
L_main34:
;vreg_click_example.c,236 :: 		}
L_main33:
;vreg_click_example.c,238 :: 		DAC_Output(value);
	MOVF        _value+0, 0 
	MOVWF       FARG_DAC_Output_valueDAC+0 
	MOVF        _value+1, 0 
	MOVWF       FARG_DAC_Output_valueDAC+1 
	CALL        _DAC_Output+0, 0
;vreg_click_example.c,239 :: 		output = getADC(1)/1.82;
	MOVLW       1
	MOVWF       FARG_getADC_channel+0 
	CALL        _getADC+0, 0
	CALL        _word2double+0, 0
	MOVLW       195
	MOVWF       R4 
	MOVLW       245
	MOVWF       R5 
	MOVLW       104
	MOVWF       R6 
	MOVLW       127
	MOVWF       R7 
	CALL        _Div_32x32_FP+0, 0
	CALL        _double2word+0, 0
	MOVF        R0, 0 
	MOVWF       _output+0 
	MOVF        R1, 0 
	MOVWF       _output+1 
;vreg_click_example.c,240 :: 		ProcessValue(output,2);   // Writes measured value to Lcd
	MOVF        R0, 0 
	MOVWF       FARG_processValue_pv+0 
	MOVF        R1, 0 
	MOVWF       FARG_processValue_pv+1 
	MOVLW       2
	MOVWF       FARG_processValue_channel+0 
	CALL        _processValue+0, 0
;vreg_click_example.c,241 :: 		Delay_ms(10);                  // Wait 10ms
	MOVLW       26
	MOVWF       R12, 0
	MOVLW       248
	MOVWF       R13, 0
L_main35:
	DECFSZ      R13, 1, 1
	BRA         L_main35
	DECFSZ      R12, 1, 1
	BRA         L_main35
	NOP
;vreg_click_example.c,242 :: 		}
	GOTO        L_main3
;vreg_click_example.c,244 :: 		}
L_end_main:
	GOTO        $+0
; end of _main
